﻿using ProjectTrolleybus.Entities;

namespace ProjectTrolleybus.Drawnings;

/// <summary>
/// Расширение для класса EntityTrolleyB
/// </summary>
public static class ExtentionDrawningTrolleyB
{
    /// <summary>
    /// Разделитель для записи информации по объекту в файл
    /// </summary>
    private static readonly string _separatorForObject = ":";

    /// <summary>
    /// Создание объекта из строки
    /// </summary>
    /// <param name="info">Строка с данными для создания объекта</param>
    /// <returns>Объект</returns>
    public static DrawningTrolleyB? CreateDrawningTrolleyB(this string info)
    {
        string[] strs = info.Split(_separatorForObject);
        EntityTrolleyB? trolleyB = EntityTrolleybus.CreateEntityTrolleybus(strs);
        if (trolleyB != null)
        {
            return new DrawningTrolleybus((EntityTrolleybus)trolleyB);
        }

        trolleyB = EntityTrolleyB.CreateEntityTrolleyB(strs);
        if (trolleyB != null)
        {
            return new DrawningTrolleyB(trolleyB);
        }

        return null;
    }

    /// <summary>
    /// Получение данных для сохранения в файл
    /// </summary>
    /// <param name="drawningTrolleyB">Сохраняемый объект</param>
    /// <returns>Строка с данными по объекту</returns>
    public static string GetDataForSave(this DrawningTrolleyB drawningTrolleyB)
    {
        string[]? array = drawningTrolleyB?.EntityTrolleyB?.GetStringRepresentation();

        if (array == null)
        {
            return string.Empty;
        }

        return string.Join(_separatorForObject, array);
    }
}
