﻿namespace ProjectTrolleybus.MovementStrategy;

/// <summary>
/// Интерфейс для работы с перемещаемым объектом
/// </summary>
public interface IMoveableObject
{
    /// <summary>
    /// Получение координаты объекта
    /// </summary>
    ObjectParameters? GetObjectPosition {  get; }

    /// <summary>
    /// Шаг объекта
    /// </summary>
    int GetStep {  get; }

    /// <summary>
    /// Попытка переместить объект в указанном направлении
    /// </summary>
    /// <param name="direction"></param>
    /// <returns></returns>
    bool TryMoveObject(MovementDirection direction);
}
